VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Chat - Client"
   ClientHeight    =   3540
   ClientLeft      =   45
   ClientTop       =   735
   ClientWidth     =   5160
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   3540
   ScaleWidth      =   5160
   StartUpPosition =   2  'CenterScreen
   Begin MSWinsockLib.Winsock wskClient 
      Left            =   240
      Top             =   2520
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.TextBox txtMsg 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "Hi, how are you?"
      Top             =   3120
      Width           =   3615
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "&Send"
      Default         =   -1  'True
      Height          =   300
      Left            =   3840
      TabIndex        =   1
      Top             =   3120
      Width           =   1215
   End
   Begin VB.TextBox txtChat 
      Appearance      =   0  'Flat
      Height          =   2055
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   960
      Width           =   4935
   End
   Begin VB.TextBox txtServerIP 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1080
      TabIndex        =   3
      Text            =   "< SERVER IP >"
      Top             =   120
      Width           =   1815
   End
   Begin VB.TextBox txtServerPort 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Text            =   "< SERVER PORT >"
      Top             =   480
      Width           =   1815
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   300
      Left            =   3120
      TabIndex        =   5
      Top             =   120
      Width           =   975
   End
   Begin VB.CommandButton cmdDisconnect 
      Caption         =   "Disconnect"
      Height          =   300
      Left            =   4080
      TabIndex        =   6
      Top             =   120
      Width           =   975
   End
   Begin VB.Label lblStatus 
      Caption         =   "Ready to connect..."
      Height          =   255
      Left            =   3120
      TabIndex        =   9
      Top             =   540
      Width           =   1935
   End
   Begin VB.Label Label1 
      Caption         =   "Server IP:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   165
      Width           =   855
   End
   Begin VB.Label Label2 
      Caption         =   "Server Port:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   525
      Width           =   975
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim svrPort As String
Dim svrIP As String
Dim msg As String

Private Sub cmdConnect_Click()
    svrPort = txtServerPort.Text
    svrIP = txtServerIP.Text
    wskClient.Close
    wskClient.RemoteHost = svrIP
    wskClient.RemotePort = svrPort
    wskClient.Connect
    txtServerPort.Enabled = False
    txtServerIP.Enabled = False
    cmdConnect.Enabled = False
    cmdDisconnect.Enabled = True
    lblStatus.Caption = "Connecting to server..."
End Sub

Private Sub cmdDisconnect_Click()
    wskClient.Close
    lblStatus.Caption = "Disconnected to server..."
    txtServerPort.Enabled = True
    txtServerIP.Enabled = True
    cmdConnect.Enabled = True
    cmdDisconnect.Enabled = False
    txtChat.Text = "* Disconnected..."
End Sub

Private Sub cmdSend_Click()
    msg = txtMsg.Text
    If wskClient.State = sckConnected Then
        txtChat.Text = txtChat & vbNewLine & "<Client:> " & msg
        wskClient.SendData msg
        DoEvents
        txtMsg.Text = ""
    Else
        txtChat.Text = "* Not connected to server..."
    End If
End Sub

Private Sub Form_Load()
    txtServerPort.Text = "12345"
    txtServerIP.Text = wskClient.LocalIP
    cmdDisconnect.Enabled = False
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

Private Sub txtChat_Change()
    txtChat.SelStart = Len(txtChat.Text)
End Sub

Private Sub wskClient_Close()
    If wskClient.State <> sckClosed Then wskClient.Close
    MsgBox "Connection to server lost...", vbInformation + vbOKOnly, "Error 2"
    cmdDisconnect_Click
End Sub

Private Sub wskClient_Connect()
    If wskClient.State <> sckClosed Then
        lblStatus.Caption = "Connected to server..."
    End If
    txtChat.Text = "Welcome To Chat..."
End Sub

Private Sub wskClient_DataArrival(ByVal bytesTotal As Long)
    wskClient.GetData msg
    txtChat.Text = txtChat.Text & vbNewLine & "<Server:> " & msg
    DoEvents
End Sub

Private Sub wskClient_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    MsgBox "Could not connect to server...", vbInformation + vbOKOnly, "Error 1"
    cmdDisconnect_Click
End Sub
