VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Chat - Server"
   ClientHeight    =   3540
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   5160
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   ScaleHeight     =   3540
   ScaleWidth      =   5160
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   300
      Left            =   4080
      TabIndex        =   9
      Top             =   120
      Width           =   975
   End
   Begin MSWinsockLib.Winsock wskServer 
      Left            =   240
      Top             =   2400
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.CommandButton cmdListen 
      Caption         =   "Listen"
      Height          =   300
      Left            =   3120
      TabIndex        =   5
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox txtServerPort 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Text            =   "< PORT >"
      Top             =   480
      Width           =   1815
   End
   Begin VB.TextBox txtServerIP 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1080
      TabIndex        =   3
      Text            =   "< IP ADDRESS>"
      Top             =   120
      Width           =   1815
   End
   Begin VB.TextBox txtChat 
      Appearance      =   0  'Flat
      Height          =   2055
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   960
      Width           =   4935
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "&Send"
      Default         =   -1  'True
      Height          =   300
      Left            =   3840
      TabIndex        =   1
      Top             =   3120
      Width           =   1215
   End
   Begin VB.TextBox txtMsg 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "Hi, How are you?"
      Top             =   3120
      Width           =   3615
   End
   Begin VB.Label Label2 
      Caption         =   "Local Port:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   530
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "IP Address:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   170
      Width           =   855
   End
   Begin VB.Label lblStatus 
      Caption         =   "Server is Closed..."
      Height          =   255
      Left            =   3120
      TabIndex        =   6
      Top             =   540
      Width           =   1935
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim svrPort As String
Dim msg As String

Private Sub cmdListen_Click()
    svrPort = txtServerPort.Text
    wskServer.Close
    wskServer.LocalPort = svrPort
    wskServer.Listen
    lblStatus.Caption = "Waiting for connection..."
    txtServerPort.Enabled = False
    cmdListen.Enabled = False
    cmdStop.Enabled = True
End Sub

Private Sub cmdSend_Click()
    msg = txtMsg.Text
    If wskServer.State = sckConnected Then
        txtChat.Text = txtChat & vbNewLine & "<Server:> " & msg
        wskServer.SendData msg
        DoEvents
        txtMsg.Text = ""
    Else
        txtChat.Text = "* No connection found..."
    End If
End Sub

Private Sub cmdStop_Click()
wskServer.Close
    lblStatus.Caption = "Server is closed..."
    txtServerPort.Enabled = True
    cmdStop.Enabled = False
    cmdListen.Enabled = True
    txtChat.Text = "* Session Closed..."
End Sub

Private Sub Form_Load()
    txtServerIP.Text = wskServer.LocalIP
    txtServerIP.Enabled = False
    txtServerPort.Text = "12345"
    cmdStop.Enabled = False
End Sub
Private Sub mnuFileExit_Click()
    Unload Me
End Sub
Private Sub txtChat_Change()
    txtChat.SelStart = Len(txtChat.Text)
End Sub
Private Sub wskServer_Close()
    If wskServer.State <> sckClosed Then wskServer.Close
    cmdListen_Click
    txtChat.Text = "The Client have Quit the Session..."
End Sub

Private Sub wskServer_ConnectionRequest(ByVal requestID As Long)
    wskServer.Close
    wskServer.Accept requestID
    lblStatus.Caption = "Connection Success..."
    txtChat.Text = "The Client is Successfully Connected..."
End Sub

Private Sub wskServer_DataArrival(ByVal bytesTotal As Long)
    wskServer.GetData msg
    DoEvents
    txtChat.Text = txtChat.Text & vbNewLine & "<Client:> " & msg
End Sub

Private Sub wskServer_Error(ByVal Number As Integer, description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    MsgBox "Unexpected error occured...", vbCritical + vbOKOnly, "Error"
End Sub
